#vehicle_drive.rb
#Auther :TAK2HATA
#Update 20140914
#site: http://sketchup-onigiri.jimdo.com/
###日本語
#General disclaimer
#I MAKES NO GUARANTEE OF VALIDITY about this script.
#Please use this script at your own risk.
##免責事項
##このスクリプトによって如何なる損害が発生しても製作者は責任を負いません。各人の責任においてご使用ください。
#
require "sketchup.rb"
module TAK2HATA
module T2H_VEHICLE_MOVER
module T2H_Commonfunc
	def get_page_transition()
		pg_stimes = []
		df_dtime = Sketchup.active_model.options["SlideshowOptions"]["SlideTime"]
		df_trtime = Sketchup.active_model.options["PageOptions"]["TransitionTime"]
		atime = 0.0#蓄積開始時刻
		#btime = []#蓄積開始時刻
		Sketchup.active_model.pages.find_all{|pg| pg.label == pg.name}.each{|pg|
			#btime = 0.0#シーンの継続時間
			if pg_stimes != []##最初のページのトランジション時間は無視
				if pg.transition_time == -1.0
					atime += df_trtime
				else
					atime += pg.transition_time
				end
			end
			#FrameChangeObserver を使用する際に停止期間はframeを拾えない
			if pg.delay_time == -1.0
				dtime = df_dtime
			else
				dtime = pg.delay_time
			end
			pg_stimes.push [pg.name , atime , dtime]
			#atime += dtime
		}
		
		return pg_stimes
	end
	def get_initial_state()
		#adic = @vehicle.definition.attribute_dictionaries["T2H_VD_INITIAL_STATE"]
		adic = @vehicle.definition.get_attribute("T2H_VD_INITIAL_STATE","WHEEL_fr_TR","")
		@init_tr = {}
		if adic == ""
			[:fr,:fl,:rr,:rl].each{|wbst|
				p "init"
				@init_tr[wbst] = @wheels[wbst].transformation
				@vehicle.definition.set_attribute("T2H_VD_INITIAL_STATE","WHEEL_#{wbst}_TR",@init_tr[wbst].to_a)
			}
		else
			[:fr,:fl,:rr,:rl].each{|wbst|
				tra = @vehicle.definition.get_attribute("T2H_VD_INITIAL_STATE","WHEEL_#{wbst}_TR",@init_tr[wbst].to_a , Geom::Transformation.new.to_a)
				@init_tr[wbst] = Geom::Transformation.new(tra)
				@wheels[wbst].transformation = @init_tr[wbst]
			}
		end
	end
	def check_vehicle_comp( sel )
		#選択しているコンポーネントが車両として使えるかの判定と情報読み取り
		@vehicle = sel
		@wheels = {}
		@clspts = []
		wb = is_vehicle(sel)
		if wb
			@wheels[:wb] = wb
			@wheels[:wb].definition.entities.each{|e|
				if e.is_a?(Sketchup::ComponentInstance)
					if e.name == "wheel_fr"
						@wheels[:fr] = e
					elsif e.name == "wheel_fl"
						@wheels[:fl] = e
					elsif e.name == "wheel_rr"
						@wheels[:rr] = e
					elsif e.name == "wheel_rl"
						@wheels[:rl] = e
					elsif e.name == "collision"
						cetr = wb.transformation * e.transformation
						e.definition.entities.each{|ce|
							if ce.is_a?(Sketchup::Edge)
								ce.vertices.each{|vt|
									pt = vt.position.transform(cetr) 
									if not @clspts.index(pt)
										@clspts.push pt
									end
								}
							end
						}
					end
				elsif e.is_a?(Sketchup::Text)
					if e.text == "center of gravity"
						#重心点の指定
						@pt_cog = e.point
					end
				end
			}
			if not @pt_cog
				@pt_cog = wb.bounds.center
			end
			if @wheels[:wb] and @wheels[:fr] and @wheels[:fl] and @wheels[:rr] and @wheels[:rl]
				@wheelbase = @wheels[:fr].transformation.origin.distance(@wheels[:rr].transformation.origin)
				@tread_front = @wheels[:fr].transformation.origin.distance(@wheels[:fl].transformation.origin)
				@tread_back = @wheels[:fr].transformation.origin.distance(@wheels[:rl].transformation.origin)
				get_initial_state()
				@vehicle.set_attribute("T2H_VEHICLE_MOVER","CLASS","VEHICLE")
				return true
			end
		end

		return false
	end
	def is_vehicle(sel)
		if sel.is_a?(Sketchup::ComponentInstance)
			wb = sel.definition.entities.find{|e| e.is_a?(Sketchup::ComponentInstance) and ( e.name == "wheel_base" or e.definition.name == "wheel_base" )}
			if wb
				return wb
			end
		end
		return nil
	end
	def	check_tracks()
		#アクティブなグループ内に軌跡が残っているか？
		tracklist = {}
		if @vehicle
			ents = Sketchup.active_model.active_entities
			@tracks = ents.find_all{|e| e.is_a?(Sketchup::ComponentInstance) and e.definition.name == "tracks_#{@vehicle.definition.name}" }
			if @tracks and @tracks.length > 0
				@last_track = @tracks[0]
				@tracks.each{|e|
					tracklist[e.name.to_i] = e
					if e.name.to_i > @last_tracknum
						@last_tracknum = e.name.to_i
					end
				}
			end
		end
		@tracklist = []
		if tracklist != []
		@tracklist = tracklist.keys.sort.map{|i| tracklist[i] }
		else
		end
	end
	def add_layer( lyname )
		if not Sketchup.active_model.layers[ lyname ]
			Sketchup.active_model.layers.add lyname
		end
	end

end#module
#軌跡アニメーション用
class T2H_Track_moive
	include T2H_Commonfunc
	def nextFrame(view)
		@vehicle.transformation = @movelist[@t][0]
		@wheels[:fr].transformation = @movelist[@t][1]
		@wheels[:fl].transformation = @movelist[@t][2]
		@wheels[:rr].transformation = @movelist[@t][3]
		@wheels[:rl].transformation = @movelist[@t][4]
		if @prevtr
			pre_o = @prevtr.origin
			cur_o = @vehicle.transformation.origin
			if @check_camera == true
				new_eye = view.camera.eye + pre_o.vector_to( cur_o )
			else
				new_eye = view.camera.eye
			end
			if @check_target == true
				new_target = view.camera.target + pre_o.vector_to( cur_o )
			else
				new_target = view.camera.target
			end
			view.camera.set(new_eye, new_target, view.camera.up)
		end
		Sketchup.set_status_text( "frame:#{@t}" )
		@prevtr = @movelist[@t][0]
		@t += 1
		@t = 0 if @t > @movelist.length-1
		@vehicle.set_attribute("T2H_VEHICLE_MOVER","CFRAME",@t)
		view.show_frame
	end

	def initialize()
		#@t = 0
		@last_tracknum=0
		@check_camera = false
		@check_target = false
		sel = Sketchup.active_model.selection[0]
		if not sel
			return
		end
		if check_vehicle_comp(sel) == false
			p "not find"
			return
		end
		check_tracks()
		@movelist = []
		@tracklist.each{|track|
			ttr = []
			ttr[0] = track.transformation
			ttr[1] = Geom::Transformation.new(track.get_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_FR"))
			ttr[2] = Geom::Transformation.new(track.get_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_FL"))
			ttr[3] = Geom::Transformation.new(track.get_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_RR"))
			ttr[4] = Geom::Transformation.new(track.get_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_RL"))
			@movelist.push ttr
		}
		@t = @vehicle.get_attribute("T2H_VEHICLE_MOVER","CFRAME",0)
	end
end#class
class Frame_Mover
	include T2H_Commonfunc
	class FrameChangeObserver 
		include T2H_Commonfunc
		def initialize()
			#@current_page = Sketchup.active_model.pages.selected_page 
			@last_tracknum=0
			sel = Sketchup.active_model.selection[0]
			if not sel
				return
			end
			if check_vehicle_comp(sel) == false
				p "not find"
				return
			end
			check_tracks()
			@movelist = []
			@tracklist.each{|track|
				ttr = []
				ttr[0] = track.transformation
				ttr[1] = Geom::Transformation.new(track.get_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_FR"))
				ttr[2] = Geom::Transformation.new(track.get_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_FL"))
				ttr[3] = Geom::Transformation.new(track.get_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_RR"))
				ttr[4] = Geom::Transformation.new(track.get_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_RL"))
				@movelist.push ttr
			}
			#ページごとの開始時刻を取得
			@pg_stimes = get_page_transition()
		end
		def index_pages(page)
			pages = Sketchup.active_model.pages
			pindx = 0
			pages.count.times{|i|
				if page == pages[i]
					return i
				end
			}
		end
		def frameChange(fromPage, toPage, percent_done)
			atime = 0.0
			pages = Sketchup.active_model.pages
			if not fromPage.nil?
				atime = @pg_stimes[index_pages(fromPage)][1]
			end
			btime = @pg_stimes[index_pages(toPage)][1]
			@fps = 30
			sframe = @vehicle.get_attribute("T2H_VEHICLE_MOVER","SFRAME",0)
			eframe = @vehicle.get_attribute("T2H_VEHICLE_MOVER","EFRAME",0)
			cframe = (((btime - atime ) * percent_done + atime ) * @fps ).to_i
			cframe = cframe - sframe.to_i
			if cframe >= 0 and @movelist.size > cframe
				@vehicle.transformation = @movelist[cframe][0]
				@wheels[:fr].transformation = @movelist[cframe][1]
				@wheels[:fl].transformation = @movelist[cframe][2]
				@wheels[:rr].transformation = @movelist[cframe][3]
				@wheels[:rl].transformation = @movelist[cframe][4]
			end
		end 
	end 
	def show_frame_dialog()
		if @vehicle_frame_wdlg
			@vehicle_frame_wdlg.bring_to_front
			return
		end

		dirname = File.dirname(__FILE__)
		htmfile = File.join( dirname, "t2h_frame_mover.html" )

	    model = Sketchup.active_model
	    @vehicle_frame_wdlg = UI::WebDialog.new("Vehicle Driver Frame Manager", true, "VehicleDriverFrameManager", 500, 150, 150, 150, true)
	    if RUBY_PLATFORM[/darwin/]
			@vehicle_frame_wdlg.set_file('/'+htmfile)
		else
			@vehicle_frame_wdlg.set_file(htmfile)
		end


		@vehicle_frame_wdlg.set_on_close{
			@vehicle_frame_wdlg = nil
		}
		@vehicle_frame_wdlg.add_action_callback("set_vehicle_frame"){|d,t|
			@vehicle.set_attribute("T2H_VEHICLE_MOVER","SFRAME",t.split("|")[0].to_i)
			@vehicle.set_attribute("T2H_VEHICLE_MOVER","EFRAME",t.split("|")[1].to_i)
		}
		@vehicle_frame_wdlg.add_action_callback("move_frame"){|d,t|
			#t:フレーム番号
			sframe = @vehicle.get_attribute("T2H_VEHICLE_MOVER","SFRAME",0)
			eframe = @vehicle.get_attribute("T2H_VEHICLE_MOVER","EFRAME",0)
			cframe = t.to_i - sframe
			if cframe >= 0 and @movelist.length > cframe
				@vehicle.transformation = @movelist[cframe][0]
				@wheels[:fr].transformation = @movelist[cframe][1]
				@wheels[:fl].transformation = @movelist[cframe][2]
				@wheels[:rr].transformation = @movelist[cframe][3]
				@wheels[:rl].transformation = @movelist[cframe][4]
				@vehicle.set_attribute("T2H_VEHICLE_MOVER","CFRAME",t.to_i)
			end
		}
		@vehicle_frame_wdlg.add_action_callback("move_scene"){|d,t|
			if Sketchup.active_model.pages.count > 1
				t1 = t.to_f / @fps
				t2 = 0.0
				@pg_stimes.each{|pgname,atime,dtime|
					t2 += dtime if t1 > atime
				}
				Sketchup.active_model.pages.show_frame_at( t1 + t2 )
			end
		}
		@vehicle_frame_wdlg.add_action_callback("set_page"){|d,t|
			if Sketchup.active_model.pages.count > 1
				camera = Sketchup.active_model.pages[t.to_i].camera
				Sketchup.active_model.active_view.camera = camera
			end
			#Sketchup.active_model.pages.selected_page=Sketchup.active_model.pages[t.to_i]
		}
		@vehicle_frame_wdlg.add_action_callback("set_transition"){|d,list|
			if Sketchup.active_model.pages.count > 1
				tmarr = list.split("|")
				df_dtime = Sketchup.active_model.options["SlideshowOptions"]["SlideTime"]
				df_trtime = Sketchup.active_model.options["PageOptions"]["TransitionTime"]
				atime = 0.0
				i = 0
				Sketchup.active_model.pages.find_all{|pg| pg.label == pg.name}.each{|pg|
					if i > 0##一番最初のページのトランジションを変更しないように
						pg.transition_time=(tmarr[i].to_f )/@fps - atime
					end
					pgname,btime,dtime = @pg_stimes[i]
					atime = (tmarr[i].to_f )/@fps
					@pg_stimes[i] = [ pgname,(tmarr[i].to_f )/@fps,dtime ]
					i += 1
				}
			end
		}
		@vehicle_frame_wdlg.add_action_callback("assign_anim"){|d,t|
			@assigned_anim_id = Sketchup::Pages.add_frame_change_observer(FrameChangeObserver.new)
			@vehicle.set_attribute("T2H_VEHICLE_MOVER","ASSIGN_ANIM",@assigned_anim_id)
		}
	    @vehicle_frame_wdlg.show{
			init()
			@pg_stimes = get_page_transition()
			totalframes = Sketchup.active_model.pages.slideshow_time * @fps
			if totalframes < @tracklist.length
				totalframes = @tracklist.length
			end
			sframe = @vehicle.get_attribute("T2H_VEHICLE_MOVER","SFRAME",0)
			eframe = @vehicle.get_attribute("T2H_VEHICLE_MOVER","EFRAME",@tracklist.length)

			#フレーム数を指定してから明ける
			@vehicle_frame_wdlg.execute_script("set_text('total_frames',[#{totalframes}]);")
			@vehicle_frame_wdlg.execute_script("set_text('fps',[#{@fps}]);")
			@vehicle_frame_wdlg.execute_script("create_current_slider(#{totalframes},[#{@tracklist.length}]);")
			kylist = @pg_stimes.map{|pgname,atime,dtime| "\"" + pgname + "\"" }
			vllist = @pg_stimes.map{|pgname,atime,dtime| "\"" + ( atime * @fps ).to_s + "\"" }
			vhrange= ["0","\"#{@tracklist.length}\""]
			#v2llist = @pg_stimes.map{|pgname,atime,dtime| "\"" + ( dtime * @fps ).to_s + "\"" }
			@vehicle_frame_wdlg.execute_script(%Q{create_slider(#{totalframes},[#{vllist.join(",")}],[#{kylist.join(",")}]);})
			@vehicle_frame_wdlg.execute_script(%Q{page_slider_tooltips(#{kylist.size},[#{kylist.join(",")}]);})
			@vehicle_frame_wdlg.execute_script(%Q{create_vh_slider(#{totalframes},#{sframe},#{eframe});})
		}
	end
	def init()
		@t = 0
		@last_tracknum=0
		@check_camera = false
		@check_target = false
		@fps=30
		sel = Sketchup.active_model.selection[0]
		if not sel
			return
		end
		if check_vehicle_comp(sel) == false
			UI.messagebox "please select Vehicle before start command!"
			return
		end
		check_tracks()
		@movelist = []
		@tracklist.each{|track|
			ttr = []
			ttr[0] = track.transformation
			ttr[1] = Geom::Transformation.new(track.get_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_FR"))
			ttr[2] = Geom::Transformation.new(track.get_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_FL"))
			ttr[3] = Geom::Transformation.new(track.get_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_RR"))
			ttr[4] = Geom::Transformation.new(track.get_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_RL"))
			@movelist.push ttr
		}
		assigned_anim_id = @vehicle.get_attribute("T2H_VEHICLE_MOVER","ASSIGN_ANIM")
		if assigned_anim_id
			Sketchup::Pages.remove_frame_change_observer(assigned_anim_id)
			@vehicle.set_attribute("T2H_VEHICLE_MOVER","ASSIGN_ANIM",nil)
		end
	end
end#class
class Driving_vehicle
	include T2H_Commonfunc
	def draw(view)
		view.line_stipple="_"
		view.line_width=2
		view.drawing_color="red"
		@prptss.each{|pts|
			view.draw_polyline( pts )
		}
		#view.line_width=2
		#view.drawing_color="blue"
		#@flplys.each{|ply,pln|
		#	view.draw_polyline( ply.map{|i| @flpts[i] } )
		#}
		if @previewhit
			vtr = @vehicle.transformation
			view.line_width=4
			view.drawing_color="green"
			@hitplanes.each{|pln,ply|
				view.draw_polyline( (-1..2).map{|i| ply[i].transform(vtr) })
			}
		end
		if not @first
			#view = Sketchup.active_model.active_view
			view.line_width=4
			view.drawing_color="green"
			@flplys.each{|tri,pln|
				view.draw_polyline( (-1..2).map{|i| @flpts[tri[i]] })
			}
			UI.messagebox("GET:#{@flplys.size} faces for road")
			@first = true
		end
		show_state()
		#Sketchup.set_status_text( "[ARROW] to MOVE,[L-Drag] to Look Around,[SHIFT] to RUN,[R-Click] to change SPEED" )
	end
	def initialize(lim_depth,lim_mats,lim_slope,wheeldiv,maxhandle,speed,igarea,use_road,use_collision)
		@previewhit = false
		@wheelbase = 2.5.m
		@tread_front = 1.5.m
		@tread_back = 1.5.m
		@last_tracknum = 0
		@speed = speed.km||10.km #/hour
		@igarea=igarea
		@preview_steps = 3
		@move_steps = 4
		@wheeldiv = wheeldiv
		@maxhandle = maxhandle
		@lim_depth=lim_depth||2
		@lim_mats=lim_mats
		#p lim_mats
		@lim_slope=lim_slope.degrees||90.degrees
		@lim_area=0.0
		@fps=30
		@rad=0
		@clspts =[]
		@forcevec = Geom::Vector3d.new(0,0,0)
		@log = []
		@chk_colbody = use_collision
		if @previewhit
			@hitplanes=[]
		end
		add_layer( "vehicle_track" )
		sel = Sketchup.active_model.selection[0]
		if not sel
			Sketchup.active_model.select_tool nil
		end
		if check_vehicle_comp(sel) == false
			p "not find"
			Sketchup.active_model.select_tool nil
		end
		check_tracks()
		@handle_ang = @vehicle.get_attribute("T2H_VEHICLE_MOVER","WHEEL_HANG",0.0)
		@vehicle.set_attribute("T2H_VEHICLE_MOVER","WHEEL_HANG",0.0)
		@flplys , @flpts , @bbcenter ,@fllns = [],[],[0,0,0],[]
		if use_road != 'false'
			@flplys , @flpts , @bbcenter ,@fllns= get_floor_pts_plys()
			if @flplys == []
				UI.messagebox "No Face for Road!"
				#Sketchup.active_model.select_tool nil
				#eturn nil
			end
		end

		ltr = @vehicle.transformation
		ltr,move_wh,mwdist = layon_slope2(ltr)

		@vehicle.transformation = ltr
		#####
		if @previewhit
			@hitplanes = get_hitplanes(ltr)
		end
		handling_wheels()
		preview_ptss()
		reset
	end
	def show_webdialog()
	end

	def get_floor_pts_plys()
		#走行面の制限:  <階層,=材質、<勾配、>面積
		#flptsH = {}
		flplys = []
		flpts = {}
		fllns = Hash.new(0.0)
		xlist = []
		ylist = []
		zlist = []
		#判定用に頂点リストを作っておく
		#ついでにポリゴンで面情報もリスト化
		#各頂点ごとに一番長いエッジの長さもリスト化
		ents=Sketchup.active_model.active_entities
		tr=Geom::Transformation.new
		depth=0
		cnt=0
		get_floor_pts_plys_do(flplys,flpts,fllns, xlist, ylist, zlist,ents,tr,depth,cnt)
		xlist.sort!
		ylist.sort!
		zlist.sort!
		#p xlist
		if xlist != [] and ylist != [] and zlist != []
		bbcenter = Geom::Point3d.new(xlist[(xlist.size/2).to_i],ylist[(ylist.size/2).to_i],zlist[(zlist.size/2).to_i])
		else
		bbcenter=[0,0,0]
		end
		return flplys , flpts , bbcenter , fllns
	end
	def get_floor_pts_plys_do(flplys,flpts,fllns, xlist, ylist, zlist,ents,tr,depth,cnt)
		#はじめに設置面を取得してインデックスをつけて高速化する
	ents.find_all{|e| e.is_a?(Sketchup::Face) }.each{|fc|
		if @lim_mats == [] or @lim_mats.include?(fc.material) or @lim_mats.include?(fc.back_material)
		fnvec = fc.normal.transform(tr)
		ang = fnvec.angle_between(Geom::Vector3d.new(0,0,1))
		if @lim_slope == 90.degrees or ang < @lim_slope or ang >( @lim_slope + 90.degrees )
		if @igarea == 'false' or fc.area > ( 300.mm * 300.mm )
			#plane = fc.plane
			plane=[ fc.vertices[0].position.transform(tr), fnvec]
			msh = fc.mesh(0)
			msh.count_polygons.times{|i|
				triangle = []
				#tpt = []
				mshpts = msh.polygon_points_at(i+1)
				mshpts.each{|pt1|
					sy = fc.vertices.find{|vt| vt.position == pt1 }
					pt = pt1.transform(tr)
					flpts[sy] = pt
					dist = mshpts.map{|pt2| pt2.distance(pt1) }.max
					if fllns[sy] < dist
						#任意点に接続するポリゴン辺の最大長さを取得しておく（距離で除外する条件をつけるため）
						fllns[sy] = dist
						##sy.edges.map{|ed| ed.start.position.transform(tr).distance(ed.end.position.transform(tr)) }.max
					end
					xlist.push pt.x
					ylist.push pt.y
					zlist.push pt.z
					triangle.push sy
					#tpt.push pt
				}
				if triangle.size > 2
					flplys.push [triangle,plane]
					cnt += 1
				end
			}
		end
		end
		end
	}
		if depth + 1.0 > @lim_depth
			return
		end

		ents.find_all{|e| e.is_a?(Sketchup::ComponentInstance) }.each{|ci|
			if ci.definition != @vehicle.definition and ci.get_attribute("T2H_VEHICLE_MOVER","CLASS","") != "VEHICLE"
				get_floor_pts_plys_do(flplys,flpts,fllns, xlist, ylist, zlist,ci.definition.entities,ci.transformation*tr,depth + 1,cnt)
			end
		}
		ents.find_all{|e| e.is_a?(Sketchup::Group) }.each{|gr|
			get_floor_pts_plys_do(flplys,flpts,fllns, xlist, ylist, zlist,gr.entities,gr.transformation*tr,depth + 1,cnt)
		}
	end
	def reset
		#Sketchup.active_model.active_view.animation = nil
	end
	def activate
		show_state
	end
	def deactivate(view)
	end
	
	def onCancel(flag, view)
		reset
		Sketchup.active_model.select_tool nil
	end

	def getMenu(menu)

	end
	def onKeyDown(key, repeat, flags, view)

	end
	def onKeyUp(key, repeat, flags, view)
		#case key
		if key == VK_UP
			move_vehicle(true)
		elsif key == VK_DOWN
			move_vehicle(false)
		elsif key == VK_RIGHT
			if @handle_ang < @maxhandle
				@handle_ang +=  @maxhandle.to_f/5.0
				@handle_ang = 0.0 if @handle_ang.abs < @maxhandle.to_f/10.0
				handling_wheels()
			end
		elsif key == VK_LEFT
			if @handle_ang > - @maxhandle
				@handle_ang += - @maxhandle.to_f/5.0
				@handle_ang = 0.0 if @handle_ang.abs < @maxhandle.to_f/10.0
				handling_wheels()
			end
		elsif key == 36 or key == 91
		elsif key == 35 or key == 93
		elsif key == VK_SHIFT
		else
		end
		preview_ptss()
		draw(view)
		show_state()
	end
	def handling_wheels()
		Sketchup.active_model.start_operation("Vehicle Handle",true)
			ha = @vehicle.get_attribute("T2H_VEHICLE_MOVER","WHEEL_HANG",0.0)
			rovec = Geom::Vector3d.new(0,0,1)
			ropt1 = @wheels[:fr].transformation.origin
			ropt2 = @wheels[:fl].transformation.origin
			roang = ( ha - @handle_ang ).degrees
			@wheels[:fr].transform!(Geom::Transformation.rotation(ropt1,rovec, roang ))
			@wheels[:fl].transform!(Geom::Transformation.rotation(ropt2,rovec, roang ))
			@vehicle.set_attribute("T2H_VEHICLE_MOVER","WHEEL_HANG",@handle_ang)
		Sketchup.active_model.commit_operation
	end

	def show_state()
		Sketchup.set_status_text( "[UP/DONW] to MOVE(#{@speed.to_km}km/h)--[LEFT-RIGHT} to Rotate Handle(#{@handle_ang})--CorneringRadius:-#{@rad}-Animation:#{@fps}fps" )
	end
	def onMouseMove(flags, x, y, view)

	end
	def onMouseLeave(view)

	end
	def onLButtonUp(flags, x, y, view)

	end
	def onLButtonDown(flags, x, y, view)

	end
	def move_vehicle( goforward = true )
		Sketchup.active_model.start_operation("Vehicle Drive",true)
		if goforward == false
			sp = -@speed / 3600 / @fps
		else
			sp = @speed / 3600 / @fps
		end
		@log = []
		@move_steps.times{|mt|
			#軌跡用に残しておく情報
			atr_fr = @wheels[:fr].transformation.to_a
			atr_fl = @wheels[:fl].transformation.to_a
			atr_rr = @wheels[:rr].transformation.to_a
			atr_rl = @wheels[:rl].transformation.to_a
			atr_vh = @vehicle.transformation
			#情報終わり
			#wheel_baseの変形を基準に計算し、最終的な変形はvehicleの変形を掛け合わせる
			vh_tr = @vehicle.transformation
			gdtr,move_wh,mwdist =get_drive_tr(vh_tr,sp)
			@vehicle.transformation = gdtr
			set_wheel_position(move_wh,mwdist)
			wheel_rotate(sp)
			rvec = vh_tr.zaxis#ローカル座標系
			rvec.reverse!
			aents = Sketchup.active_model.active_entities
			cdistlist = []
			hitplanes = get_hitplanes(gdtr)###added 140614
			#check collide with collision_body
			if @chk_colbody == 'true'
				@clspts.each{|cpt0|
					cpt = cpt0.transform(vh_tr)
					ipt , cdist= raytest_local3( hitplanes ,gdtr, [cpt] , true)###added 140614
					#ipt = raytest_local2( aents , [cpt] , rvec ,true )
					if ipt
						if cdist < 5.0.mm
							lvec = Geom::Vector3d.new(0,0,500.mm)
							lvec.length = rand(5) * 100.mm + 500.mm
							cdtext = aents.add_text(%Q{#{"%0.3f" % cdist}mm},cpt,lvec)
							cdtext.material = "Red"
							cdtext.layer = "vehicle_track"
						elsif cdist < 10.0.mm
							lvec = Geom::Vector3d.new(0,0,500.mm)
							lvec.length = rand(5) * 100.mm + 500.mm
							cdtext = aents.add_text(%Q{#{"%0.3f" % cdist}mm},cpt,lvec)
							cdtext.material = "Yellow"
							cdtext.layer = "vehicle_track"
						end
						cdistlist.push cdist
					end
				}
			end
			left_track_ins(atr_vh,atr_fr,atr_fl,atr_rr,atr_rl,cdistlist)
		}
		@vehicle.set_attribute("T2H_VEHICLE_MOVER","CFRAME",(@last_tracknum-1))
		#####
		if @previewhit
			@hitplanes = get_hitplanes(@vehicle.transformation)
		end
		Sketchup.active_model.commit_operation
		#@log.each{|log| p log }
	end
	def preview_ptss()
		sp2 = @speed / 3600 / @fps
		cpts = get_vhbounds_pts
		cpts.each{|pt| pt.z = 100.mm }
		#vh_tr2
		vh_tr2 = @vehicle.transformation
		@prptss = []
		rotr = transform_cornering(sp2)
		if @ropt and @ropt2
			@prptss.push [ @ropt.transform(vh_tr2),@ropt2.transform(vh_tr2) ]
		end
		@preview_steps.times{|i|
			sp2 = sp2 * 3
			vh_tr2,move_wh,mwdist = get_drive_tr(vh_tr2,sp2)
			@prptss.push cpts.map{|pt| pt.transform(vh_tr2) }
		}
	end
	def transform_cornering(sp)
		wb_tr = @wheels[:wb].transformation
		if @handle_ang > 0
			#右まがり
			tar_wh = @wheels[:fl]
			sp = -sp
		else
			#左曲り
			tar_wh = @wheels[:fr]
		end
		rotax = Geom::Vector3d.new(0,0,1).transform( wb_tr )
		@ropt2 = tar_wh.transformation.origin
		rrpt = @wheels[:rr].transformation.origin
		rrpt.z = 0.0
		@ropt2.z = 0.0
		line1 = [ rrpt,Geom::Vector3d.new(0,1,0)  ]
		line2 = [ @ropt2, Geom::Vector3d.new(Math.tan(@handle_ang.degrees),1,0)]
		@ropt = Geom.intersect_line_line(line1, line2)
		if @ropt
			@rad = @ropt.distance(@ropt2)
			roang = ( sp / ( @rad * Math::PI ) ) * 180.0
			@ropt.transform!( wb_tr )
			@ropt2.transform!( wb_tr )
			mtr = Geom::Transformation.rotation( @ropt, rotax, roang.degrees )
			@forcevec = @ropt.vector_to( @ropt2 )
			@forcevec.length = ( sp.abs ) ** 2.0 / @rad #遠心力 inch/ss
			return mtr
		end
		return Geom::Transformation.new
	end
	def get_drive_tr(vh_tr,sp)
		wb_tr = @wheels[:wb].transformation
		@rad = 0
		@forcevec = Geom::Vector3d.new(0,0,0)#遠心力
		if @handle_ang == 0.0
			#まっすぐ
			mvec = Geom::Vector3d.new(sp,0,0).transform( wb_tr )
			mtr = Geom::Transformation.translation( mvec ) 
		else
			mtr = transform_cornering(sp)
		end
		ltr = vh_tr * mtr
		ltr,move_wh,mwdist = layon_slope2(ltr)

		return ltr,move_wh,mwdist
	end
	def pts_fortest(wheelname,vh_tr , wb_tr)
		pts = []
		if wheelname == :fr or  wheelname == :fl
			wtr2 = Geom::Transformation.new(@init_tr[wheelname].origin) * Geom::Transformation.rotation( [0,0,0],Geom::Vector3d.new(0,0,1), -@handle_ang.degrees )
		else
			wtr2 = Geom::Transformation.new(@init_tr[wheelname].origin)
		end

		r = @init_tr[wheelname].origin.z
		#車は30度まで上れると仮定（オフロードの場合は45度）
		#タイヤ幅を300.mmと仮定
		wheeldivlist = [0]
		@wheeldiv.times{|wi|
			wheeldivlist.push wi*10
			wheeldivlist.push -wi*10
		}
		wheelwide = @wheels[wheelname].definition.bounds.min.y
		[0,-wheelwide,wheelwide].each{|wy|
		wheeldivlist.each{|theta|
			pt = Geom::Point3d.new( r * Math.sin(theta.degrees) , wy , - r * Math.cos(theta.degrees) ).transform(wtr2)
			pt.transform!(wb_tr)
			pt = pt + Geom::Vector3d.new(0,0,300.mm)
			pt.transform!(vh_tr)
			#Sketchup.active_model.active_entities.add_cpoint(pt)
			pts.push pt
		}
		}

		return pts
	end
	def layon_slope2(nx_vh_tr)
		#active_entitiesローカル座標で作業する
		wb_tr = @wheels[:wb].transformation
		vw_tr = nx_vh_tr * wb_tr
		h = @wheels[:fr].bounds.height
		#ローカル座標系での車体の傾きを接地方向として使う
		rvec = nx_vh_tr.zaxis#ローカル座標系
		aents = Sketchup.active_model.active_entities
		rvec.reverse!
		opt_zero = {}#各車輪底面
		opt_float = {}#各車輪中心
		whrr_opt = @init_tr[:rr].origin.transform( wb_tr )
		whrr_opt.z = 0.0
		wb_opt = wb_tr.origin
		
		force_wh={}#各車輪にかかる荷重
		ipt = {}#各車輪軸からの接地点
		gvec = Geom::Vector3d.new(0,0,-9.8.m).transform( nx_vh_tr.inverse ) + @forcevec
		gplane = [ Geom::Point3d.new(0,0,0) , gvec ]#荷重分散用平面
		ptcog = @pt_cog.project_to_plane( gplane )
		fdist0 = {}
		fdist_sum = 0.0
		
		hitplanes = get_hitplanes(nx_vh_tr)##added 140614
		#chki = 0
		dist = 0
		[:fr,:fl,:rr,:rl].each{|wbst|
			opt_zero[wbst] = @init_tr[wbst].origin##@wheels[wbst].transformation.origin
			opt_zero[wbst].transform!( wb_tr )#車体内座標系
			opt_zero[wbst].z = 0.mm
			opt_zero[wbst].transform!(nx_vh_tr)#車体内座標系→ローカル座標系

			pts = pts_fortest(wbst,nx_vh_tr,wb_tr)
			ipt2 , dist= raytest_local3( hitplanes ,nx_vh_tr, pts )##added 140614
			#ipt2 = raytest_local2( aents , pts , rvec )
			if ipt2
				#chki += 1
				ipt[wbst] = ipt2#ローカル座標系
			else
				ipt[wbst] = opt_zero[wbst]#ローカル座標系
			end
			
			fdist0[wbst] = opt_zero[wbst].project_to_plane( gplane ).distance( ptcog )#荷重点からの距離
			fdist_sum = fdist_sum + fdist0[wbst]
			#前輪接地を原則とした場合の接地平面1,2
		}
		#p chki
		blchk = false#全てのバランスが釣り合うかのチェック
		fdist = {}
		[:fr,:fl,:rr,:rl].each{|wbst|
			if fdist0[wbst] != fdist0[:fr]
				blchk = true
			end
			fdist[wbst] = [ fdist0[wbst] / fdist_sum , wbst ]
		}
		wbstrlist = []
		if blchk == false
			fdist_arr = fdist.values.sort
			4.times{|i| wbstrlist.push fdist_arr[i][1] }
		else
			#バランスが釣り合う場合はとりあえず前輪接地を優先としてみた
			wbstrlist = [:fr,:fl,:rr,:rl]
		end
		gplane1 = Geom.fit_plane_to_points( ipt[wbstrlist[0]] , ipt[wbstrlist[1]], ipt[wbstrlist[2]] )#ローカル座標系
		gplane2 = Geom.fit_plane_to_points( ipt[wbstrlist[0]] , ipt[wbstrlist[1]], ipt[wbstrlist[3]] )#ローカル座標系
		line1 = [ ipt[wbstrlist[3]] , rvec ]
		pt1 = Geom.intersect_line_plane(line1, gplane1)
		line2 = [ ipt[wbstrlist[2]] , rvec ]
		pt2 = Geom.intersect_line_plane(line2, gplane2)
		if not pt1 and pt2
		elsif not pt2 and pt1
		elsif pt1 and pt2
			mwdist = 0.0
			ipvec1 = ipt[wbstrlist[3]].vector_to( pt1 )
			ipvec2 = ipt[wbstrlist[2]].vector_to( pt2 )
			if ipvec1.valid? and ipvec1.samedirection?( rvec )
				#gplane1
				mwdist = pt2.distance(ipt[wbstrlist[2]])
				move_wh=wbstrlist[2]
				ipt[wbstrlist[2]] = pt2
			elsif  ipvec2.valid? and ipvec2.samedirection?( rvec )
				#gplane2
				mwdist = pt1.distance(ipt[wbstrlist[3]])
				move_wh=wbstrlist[3]
				ipt[wbstrlist[3]] = pt1
			end
			mwdist = 100.mm if mwdist > 100.mm
			mpt = ipt[:rr]
			yvec = ipt[:rr].vector_to( ipt[:rl] ).normalize
			avec = ipt[:rr].vector_to( ipt[:fr] ).normalize
			zvec = avec.cross( yvec ).normalize
			xvec = yvec.cross( zvec ).normalize
			mvec = wb_opt.vector_to( whrr_opt ).reverse
			ltr = Geom::Transformation.new(xvec, yvec, zvec, mpt)  * wb_tr.inverse * Geom::Transformation.translation( mvec )
			
			return ltr,move_wh,mwdist
		end
		return nx_vh_tr

	end
	def set_wheel_position(move_wh,mwdist)
		[:fr,:fl,:rr,:rl].each{|wbst|
			#初期位置に戻すベクトル
			mv = @wheels[wbst].transformation.origin.vector_to(@init_tr[wbst].origin)
			if move_wh == wbst
				mv = mv + Geom::Vector3d.new(0.0,0.0,-mwdist.to_f)
			end
			if mv.length > 0.0
			mtr=Geom::Transformation.translation(mv)
			@wheels[wbst].transform!(mtr)
			end
		}
	end
	def get_hitplanes(vh_tr)
		hitplanes=[]
		tr = vh_tr.inverse
		maxpt = @vehicle.definition.bounds.max
		minpt = @vehicle.definition.bounds.min
		minptx = minpt.x
		maxptx = maxpt.x
		minpty = minpt.y
		maxpty = maxpt.y
		minptz = minpt.z
		maxptz = maxpt.z
		cenpt = Geom::Point3d.new( ( minptx + maxptx ) * 0.5 , ( minpty + maxpty ) * 0.5 ,( minptz + maxptz ) * 0.5 )
		cenpt2 = cenpt.transform(vh_tr)
		dl=cenpt.distance(maxpt)
		minptz = -0.9.m
		maxptz = 0.5.m
		stime = Time.now
		bcpt = @bbcenter.transform(tr)
		if bcpt.x > 0.0;dx = 1;else;dx = -1;end
		if bcpt.y > 0.0;dy = 1;else;dy = -1;end
		if bcpt.z > 0.0;dz = 1;else;dz = -1;end
		xout = Hash.new(dx)
		yout = Hash.new(dy)
		zout = Hash.new(dz)
		out = Hash.new(1)#1は範囲外を示す
		@flpts.each{|sy,pt|
			if pt.distance(cenpt2)<( dl + @fllns[sy] )
				fpts = pt.transform(tr)
				out[sy] = 0
				vx = fpts[0]
				vy = fpts[1]
				vz = fpts[2]
				if dx == 1
					if vx < minptx;xout[sy] = -dx;elsif vx < maxptx;xout[sy] = 0;end
				else
					if vx > maxptx;xout[sy] = -dx;elsif vx > minptx;xout[sy] = 0;end
				end
				if dy == 1
					if vy < minpty;yout[sy] = -dy;elsif vy < maxpty;yout[sy] = 0;end
				else
					if vy > maxpty;yout[sy] = -dy;elsif vy > minpty;yout[sy] = 0;end
				end
				if dz == 1
					if vz < minptz;zout[sy] = -dz;elsif vz < maxptz;zout[sy] = 0;end
				else
					if vz > maxptz;zout[sy] = -dz;elsif vz > minptz;zout[sy] = 0;end
				end
			end
		}
		#p "#{xout.size},#{yout.size},#{zout.size},#{out.size}/#{@flpts.size}"
		@log.push "A:#{Time.now.to_f - stime.to_f}"
		stime = Time.now
		@flplys.each{|triangle1,plane|
			xchk=0;ychk=0;zchk=0;ochk=0
			triangle1.each{|sy|
				if out[sy] == 1
					ochk =3
					break
				else
					xchk += xout[sy] if xout[sy] != 0
					ychk += yout[sy] if yout[sy] != 0
					zchk += zout[sy] if zout[sy] != 0
				end
			}
			#XYZのどれかが範囲外の場合は頂点数と同数になる。
			if [xchk.abs,ychk.abs,zchk.abs,ochk].max < 3
				triangle = triangle1.map{|sy| @flpts[sy].transform(tr) }
				hitplanes.push [plane,triangle]
			end
		}
		@log.push "B:#{Time.now.to_f - stime.to_f}"

		return hitplanes
	end

	def raytest_local3( hitplanes , vhtr, rpts , backcheck = false)#, ipt0 )
		##アクティブエンティティ内のみの判定にするため自力で行うメソッドを作る
		dist = 10.m
		tr = vhtr.inverse
		rvec = vhtr.zaxis.reverse
		ropt = rpts[0]
		ipt = nil
		rpts.each{|rpt|
			prpt = rpt.transform(tr)
			hitplanes.each{|plane,triangle|
				if Geom.point_in_polygon_2D(prpt, triangle, true)
					ray = [rpt , rvec ]
					pt = Geom.intersect_line_plane(ray, plane)
					if pt
						rpt_pt_vec = rpt.vector_to( pt )
						if rpt_pt_vec.length == 0.0
							ipt = ropt
							dist = 0.0
							break
						elsif rpt_pt_vec.angle_between( rvec ) < 0.1 or backcheck == true
							#ベクトル方向の一致確認
							if dist > rpt_pt_vec.length
								ipt = ropt + rpt_pt_vec
								dist = rpt_pt_vec.length
								if rpt_pt_vec.angle_between( rvec ) > 1.0
									dist = - dist
								end
								break if rpt_pt_vec.length < 1.mm
							end
						end
					end
				end
			}
		}
		if ipt
			return ipt,dist
		else
			return nil
		end
	end

	def wheel_rotate(sp)
		#ホイールの境界高さを直径として扱う
		wbaxis = Geom::Vector3d.new(0,1,0)##@wheels[:wb].transformation.yaxis
		[:fr,:fl,:rr,:rl].each{|wbst|
			ropt = @wheels[wbst].transformation.origin
			raxis = @wheels[wbst].transformation.yaxis
			rad = @wheels[wbst].definition.bounds.depth

			#p "#{sp}/#{rad}/3.14=#{sp/rad/Math::PI}=#{(sp/rad/Math::PI)*360}"
			cl = sp / ( rad * Math::PI )
			#p wbaxis.angle_between( raxis ).radians
			if wbaxis.angle_between( raxis ).radians > 90
				cl = -cl
			end

			rtr = Geom::Transformation.rotation( ropt , raxis , (cl * 360).degrees )
			@wheels[wbst].transform!( rtr )
		}
			
	end

	def left_track_ins(atr_vh,atr_fr,atr_fl,atr_rr,atr_rl,cdistlist)
		#一個前の軌跡位置保存用
		trackname = "tracks_#{@vehicle.definition.name}"
		track_comp = Sketchup.active_model.definitions[trackname]
		if not track_comp
			track_comp = make_track_bounds(trackname)
		end
		tins = Sketchup.active_model.active_entities.add_instance(track_comp, atr_vh)
		tins.layer = Sketchup.active_model.layers["vehicle_track"]
		@last_tracknum += 1
		tins.name = "#{@last_tracknum}"
		tins.set_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_FR",atr_fr)
		tins.set_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_FL",atr_fl)
		tins.set_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_RR",atr_rr)
		tins.set_attribute("T2H_VEHICLE_MOVER","TR_WHEEL_RL",atr_rl)
		tins.set_attribute("T2H_VEHICLE_MOVER","COLLISIONLIST",cdistlist)
	end
	def make_track_bounds(trackname)
		#軌跡の残像の形状定義
		wbbs = @wheels[:wb].definition.bounds
		wb_tr = @wheels[:wb].transformation
		fback1 = wbbs.corner(0).transform(wb_tr)
		fback2 = wbbs.corner(2).transform(wb_tr)
		ffront = Geom::Point3d.linear_combination( 0.5, wbbs.corner(1), 0.5, wbbs.corner(3) ).transform(wb_tr)
		forigin = Geom::Point3d.linear_combination( 0.5, wbbs.corner(0), 0.5, wbbs.corner(2) ).transform(wb_tr)

		vbbs = @vehicle.definition.bounds
		track_comp = Sketchup.active_model.definitions.add trackname
		trents = track_comp.entities
		
		cpts = get_vhbounds_pts
		4.times{|i|
			trents.add_cline cpts[i],cpts[i+1]
		}

		trents.add_cline forigin,ffront
		trents.add_cline ffront,fback1
		trents.add_cline ffront,fback2
		
		return track_comp
	end
	def get_vhbounds_pts()
		cpts = []
		vbbs = @vehicle.definition.bounds
		4.times{|i| cpts[i] = vbbs.corner(i);cpts[i].z = 0.0; }
		cpts2 = [ cpts[0],cpts[1],cpts[3],cpts[2],cpts[0] ]
		return cpts2
	end

end

def self.delete_tracks()
	delents = Sketchup.active_model.active_entities.find_all{|e| e.is_a?(Sketchup::ComponentInstance) and e.definition.name["tracks"] }
	delents2 = Sketchup.active_model.active_entities.find_all{|e| e.is_a?(Sketchup::Text) and e.layer.name == "vehicle_track"}
	delents.concat(delents2)
	Sketchup.active_model.active_entities.erase_entities(delents)
end
def self.show_dialog
	use_road =Sketchup.active_model.get_attribute("T2H_VEHICLE_MOVER","USE_ROAD",'true')
	use_collision =Sketchup.active_model.get_attribute("T2H_VEHICLE_MOVER","USE_COLLISION",'false')
	lim_slope=Sketchup.active_model.get_attribute("T2H_VEHICLE_MOVER","LIM_SLOPE",45)
	wheeldiv =Sketchup.active_model.get_attribute("T2H_VEHICLE_MOVER","WHEELDIV",3)
	maxhandle=Sketchup.active_model.get_attribute("T2H_VEHICLE_MOVER","MAXHANDLE",25)
	speed=Sketchup.active_model.get_attribute("T2H_VEHICLE_MOVER","SPEED",10)
	igarea =Sketchup.active_model.get_attribute("T2H_VEHICLE_MOVER","IGNORE_AREA",'true')
	dirname = File.dirname(__FILE__)
	htmfile = File.join( dirname, "t2h_settings.html" )
	wdlg = UI::WebDialog.new("T2H Vehicle Drive Settings", true, "T2H Vehicle Drive Settings", 425, 385, 150, 150, true)
	if RUBY_PLATFORM[/darwin/]
		wdlg.set_file('/'+htmfile)
	else
		wdlg.set_file(htmfile)
	end
	mats=[]
	Sketchup.active_model.materials.each{|mat|
		mats.push mat
	}
	wdlg.add_action_callback("start_drive"){|d,p|
		use_road =wdlg.get_element_value( "CHK_ROAD" )
		use_collision =wdlg.get_element_value( "CHK_COL" )
		lim_depth=wdlg.get_element_value( "LIM_DEPTH" ).to_i
		lim_mats=[]
		wdlg.get_element_value( "MATS" ).split("|").each{|mi|
			#p mats[mi.to_i]
			if mats[mi.to_i]
				lim_mats.push mats[mi.to_i]
			end
		}
		lim_slope=wdlg.get_element_value( "LIM_SLOPE" ).to_f
		wheeldiv = wdlg.get_element_value( "WHEELDIV" ).to_i
		maxhandle= wdlg.get_element_value( "MAXHANDLE" ).to_i
		speed= wdlg.get_element_value( "SPEED" ).to_i
		igarea= wdlg.get_element_value( "LIM_AREA" )
		
		Sketchup.active_model.set_attribute("T2H_VEHICLE_MOVER","USE_ROAD",use_road)
		Sketchup.active_model.set_attribute("T2H_VEHICLE_MOVER","USE_COLLISION",use_collision)
		Sketchup.active_model.set_attribute("T2H_VEHICLE_MOVER","LIM_SLOPE",lim_slope)
		Sketchup.active_model.set_attribute("T2H_VEHICLE_MOVER","WHEELDIV",wheeldiv)
		Sketchup.active_model.set_attribute("T2H_VEHICLE_MOVER","MAXHANDLE",maxhandle)
		Sketchup.active_model.set_attribute("T2H_VEHICLE_MOVER","SPEED",speed)
		Sketchup.active_model.set_attribute("T2H_VEHICLE_MOVER","IGNORE_AREA",igarea)
		wdlg.close
		Sketchup.active_model.select_tool Driving_vehicle.new(lim_depth,lim_mats,lim_slope,wheeldiv,maxhandle,speed,igarea,use_road,use_collision)
	}
	wdlg.show{
		wdlg.execute_script( "document.getElementById('LIM_MATS').length =0;" )
		mats.each{|mat|
			wdlg.execute_script( "document.getElementById('LIM_MATS').options[document.getElementById('LIM_MATS').length] = new Option('#{mat.name.gsub(/'/,"\\\\'")}','#{mat.name.gsub(/'/,"\\\\'")}')" )
		}
		wdlg.execute_script( "set_road('#{use_road}');")
		wdlg.execute_script( "set_collision('#{use_collision}');")
		wdlg.execute_script( "set_text('LIM_SLOPE',#{lim_slope});")
		wdlg.execute_script( "set_text('WHEELDIV',#{wheeldiv});")
		wdlg.execute_script( "set_text('MAXHANDLE',#{maxhandle});")
		wdlg.execute_script( "set_text('SPEED',#{speed});")
		wdlg.execute_script( "set_chk('LIM_AREA','#{igarea}');")
	}
end
def self.show_create_dialog
	dirname = File.dirname(__FILE__)
	htmfile = File.join( dirname, "t2h_car_settings.html" )
	wdlg = UI::WebDialog.new("T2H Vehicle Create Settings", true, "T2H Vehicle Create Settings", 500, 400, 150, 150, true)
	if RUBY_PLATFORM[/darwin/]
		wdlg.set_file('/'+htmfile)
	else
		wdlg.set_file(htmfile)
	end
	wdlg.add_action_callback("create_vehicle"){|d,p|
		ids = ["WB","RO","FO","FB","BB","RB","H","W","WR","RT","FT"];
		v = {}
		ids.each{|id| v[id] = wdlg.get_element_value(id).to_l}
		v["VehicleName"] = wdlg.get_element_value("VehicleName")
		v["VehicleName"] = "untitled vehicle" if v["VehicleName"] == ""
		wbpath = File.join(File.dirname(__FILE__),"wheel_base.skp")
		model=Sketchup.active_model
		dfs = model.definitions
		#model.
		vdf=dfs.add(v["VehicleName"])
		vdf.entities.add_cpoint([0,0,0])
		wbdf=dfs.load(wbpath)
		wbci=vdf.entities.add_instance(wbdf,Geom::Transformation.new)
		wbci.name="wheel_base"
		df_WB = 2500.mm
		df_FT = 1700.mm
		df_RT = 1700.mm
		df_WR = 600.mm
		df_BB = 100.mm
		df_FB = 100.mm
		df_RB = 100.mm
		df_FO = 1000.mm
		df_RO = 1200.mm
		df_W = 1800.mm
		wbdf.entities.find_all{|e| e.is_a?(Sketchup::ComponentInstance)}.each{|ci|
			case ci.name
			when "wheel_fr"
				tr=Geom::Transformation.new(Geom::Vector3d.new( (v["WB"]-df_WB),-(v["FT"]/2.0-df_FT/2.0),(v["WR"]/2.0-df_WR/2.0) ))
				ci.transform!(tr)
				tr2 = Geom::Transformation.scaling( v["WR"] / df_WR , 1 , v["WR"] / df_WR )
				ci.definition.entities.transform_entities( tr2 , ci.definition.entities.map{|e| e } )
			when "wheel_fl"
				tr=Geom::Transformation.new(Geom::Vector3d.new( (v["WB"]-df_WB),(v["FT"]/2.0-df_FT/2.0),(v["WR"]/2.0-df_WR/2.0) ))
				ci.transform!(tr)
			when "wheel_rr"
				tr=Geom::Transformation.new(Geom::Vector3d.new( 0,-(v["RT"]/2.0-df_RT/2.0),(v["WR"]/2.0-df_WR/2.0) ))
				ci.transform!(tr)
			when "wheel_rl"
				tr=Geom::Transformation.new(Geom::Vector3d.new( 0,(v["RT"]/2.0-df_RT/2.0),(v["WR"]/2.0-df_WR/2.0) ))
				ci.transform!(tr)
			when "collision"
				colents=ci.definition.entities.find_all{|e| e.get_attribute("T2H_VEHICLE_MOVER","CLASS","") == "BASE_BOTTOM" }
				tr=Geom::Transformation.new(Geom::Vector3d.new( 0,0,(v["BB"]-df_BB) ))
				ci.definition.entities.transform_entities(tr,colents) if colents != []

				colents=ci.definition.entities.find_all{|e| e.get_attribute("T2H_VEHICLE_MOVER","CLASS","") == "REAR_BOTTOM" }
				tr=Geom::Transformation.new(Geom::Vector3d.new( -(v["RO"]-df_RO) ,0,(v["RB"]-df_RB) ))
				ci.definition.entities.transform_entities(tr,colents) if colents != []

				colents=ci.definition.entities.find_all{|e| e.get_attribute("T2H_VEHICLE_MOVER","CLASS","") == "FRONT_BOTTOM1" }
				tr=Geom::Transformation.new(Geom::Vector3d.new((v["WB"]-df_WB),0,0 ))
				ci.definition.entities.transform_entities(tr,colents) if colents != []

				colents=ci.definition.entities.find_all{|e| e.get_attribute("T2H_VEHICLE_MOVER","CLASS","") == "FRONT_BOTTOM2" }
				tr=Geom::Transformation.new(Geom::Vector3d.new((v["FO"] + v["WB"] - df_FO - df_WB ),0,(v["RB"] - df_RB) ))
				ci.definition.entities.transform_entities(tr,colents) if colents != []

				colents=ci.definition.entities.find_all{|e| e.get_attribute("T2H_VEHICLE_MOVER","CLASS","") == "BASE_LEFT" }
				tr=Geom::Transformation.new(Geom::Vector3d.new( 0 , ( v["W"]/2.0 - df_W/2.0 ) ,0))
				ci.definition.entities.transform_entities(tr,colents) if colents != []

				colents=ci.definition.entities.find_all{|e| e.get_attribute("T2H_VEHICLE_MOVER","CLASS","") == "BASE_RIGHT" }
				tr=Geom::Transformation.new(Geom::Vector3d.new( 0 , -( v["W"]/2.0 - df_W/2.0 ) ,0))
				ci.definition.entities.transform_entities(tr,colents) if colents != []
			when "name_tag"
				ci.definition.entities.add_3d_text( v["VehicleName"] , TextAlignCenter , "" ,false ,false,300.mm,1.0,0.mm,true)
			end
		}
		wdlg.close
		wdlg=nil
		vdf.set_attribute("T2H_VEHICLE_MOVER","CLASS","VEHICLE")
		model.place_component(vdf)
	}
	wdlg.show{
		wdlg.execute_script( "set_text('WB','#{2500.mm}');")
		wdlg.execute_script( "set_text('RO','#{1200.mm}');")
		wdlg.execute_script( "set_text('FO','#{1000.mm}');")
		wdlg.execute_script( "set_text('FB','#{100.mm}');")
		wdlg.execute_script( "set_text('BB','#{100.mm}');")
		wdlg.execute_script( "set_text('RB','#{100.mm}');")
		wdlg.execute_script( "set_text('WR','#{600.mm}');")
		wdlg.execute_script( "set_text('RT','#{1700.mm}');")
		wdlg.execute_script( "set_text('FT','#{1700.mm}');")
		wdlg.execute_script( "set_text('W','#{1800.mm}');")
		wdlg.execute_script( "set_text('H','#{1800.mm}');")
	}
end
def self.delete_assigned_animation()
	sels = Sketchup.active_model.selection
	sels.each{|ent|
		assigned_anim_id = ent.get_attribute("T2H_VEHICLE_MOVER","ASSIGN_ANIM")
		if assigned_anim_id
			Sketchup::Pages.remove_frame_change_observer(assigned_anim_id)
			ent.set_attribute("T2H_VEHICLE_MOVER","ASSIGN_ANIM",nil)
		end
	}
end
unless( file_loaded?( "t2h_vehicle_drive.rb" ) )
	vdmenu = UI.menu("Plugins").add_submenu("Vehicle Drive")
	vdmenu.add_item("Create New Vehicle") {
		show_create_dialog
	}

	vdmenu.add_item( "Let's Drive"){
		show_dialog
	}

	vdmenu.add_item("Start Drive Animation") {
		Sketchup.active_model.select_tool nil
		Sketchup.active_model.active_view.animation = T2H_Track_moive.new
	}
	vdmenu.add_item("Stop Drive Animation") {
		Sketchup.active_model.active_view.animation = nil
	}
	vdmenu.add_item("Save movie image") {
		t2hfm = Frame_Mover.new;t2hfm.show_frame_dialog()
	}
	#vdmenu.add_item("Add Frame Change observer") {
	#	id = Sketchup::Pages.add_frame_change_observer(FrameChangeObserver.new)
	#}
	vdmenu.add_item("Delete Tracks") {
		delete_tracks()
	}
	vdmenu.add_item("Delete Assigned Animation") {
		delete_assigned_animation()
	}
	add_toolbar = []
	toolbar = UI::Toolbar.new("Vehicle Drive")
	add_toolbar.push [ "Create New Vehicle" , UI::Command.new( "Create New Vehicle" ) { show_create_dialog } , "icon_new_vehicle.png" ]
	add_toolbar.push [nil,nil,nil]
	add_toolbar.push [ "Let's Drive" , UI::Command.new( "Let's Drive" ) { show_dialog } , "icon_lets_drive.png" ]
	add_toolbar.push [ "Preview Animation" , UI::Command.new( "Start Drive Animation" ) {Sketchup.active_model.select_tool nil;Sketchup.active_model.active_view.animation = T2H_Track_moive.new } , "icon_start_anim.png" ]
	add_toolbar.push [ "Stop Preview" , UI::Command.new( "Stop Drive Animation" ) { Sketchup.active_model.active_view.animation = nil } , "icon_stop_anim.png" ]
	add_toolbar.push [ "Animation Manage" , UI::Command.new( "Frame Viewer" ) { t2hfm = Frame_Mover.new;t2hfm.show_frame_dialog() } , "icon_save_movie.png" ]
	add_toolbar.push [ "Delete Assigned Animation" , UI::Command.new( "Delete Assigned Animation" ) { delete_assigned_animation } , "icon_del_assigned.png" ]
	
	add_toolbar.push [nil,nil,nil]
	add_toolbar.push [ "Clear Tracks" , UI::Command.new( "Delete Tracks" ) { delete_tracks()} , "icon_delete_tracks.png" ]
	
	pdir = File.dirname( File.expand_path(__FILE__) )
	add_toolbar.each{|cmdname , cmd , iconimage|
		if cmdname
			cmd.large_icon = cmd.small_icon = File.join( pdir , iconimage )
			cmd.status_bar_text = cmd.tooltip = cmdname
			toolbar.add_item cmd
		else
			toolbar.add_separator
		end
	}
	
	toolbar.show if toolbar.get_last_state != 0
end

file_loaded("t2h_vehicle_drive.rb")
end
end